/* -*- Mode: C++; tab-width: 2; indent-tabs-mode: nil; c-basic-offset: 2 -*-
 *
 * The contents of this file are subject to the Netscape Public
 * License Version 1.1 (the "License"); you may not use this file
 * except in compliance with the License. You may obtain a copy of
 * the License at http://www.mozilla.org/NPL/
 *
 * Software distributed under the License is distributed on an "AS
 * IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
 * implied. See the License for the specific language governing
 * rights and limitations under the License.
 *
 * The Original Code is mozilla.org code.
 *
 * The Initial Developer of the Original Code is Netscape
 * Communications Corporation.  Portions created by Netscape are
 * Copyright (C) 1998 Netscape Communications Corporation. All
 * Rights Reserved.
 *
 * Contributor(s):
 *   Peter Hartshorn <peter@igelaus.com.au>
 *   B.J. Rossiter <bj@igelaus.com.au>
 */

#include "nsINanoXWindowService.h"

class nsNanoXWindowService : public nsINanoXWindowService
{
 public:
  nsNanoXWindowService();
  virtual ~nsNanoXWindowService();

  NS_DECL_ISUPPORTS

  NS_IMETHOD SetWindowCreateCallback(nsNanoXWindowCallback aCallback);
  NS_IMETHOD SetWindowDestroyCallback(nsNanoXWindowCallback aCallback);
  NS_IMETHOD GetWindowCreateCallback(nsNanoXWindowCallback * aCallbackOut);
  NS_IMETHOD GetWindowDestroyCallback(nsNanoXWindowCallback * aCallbackOut);


  NS_IMETHOD SetEventDispatcher(nsNanoXEventDispatcher aDispatcher);
  NS_IMETHOD GetEventDispatcher(nsNanoXEventDispatcher * aDispatcherOut);

  NS_IMETHOD SetTimeToNextTimeoutFunc(nsNanoXTimeToNextTimeoutFunc aFunc);
  NS_IMETHOD GetTimeToNextTimeoutFunc(nsNanoXTimeToNextTimeoutFunc * aFuncOut);

  NS_IMETHOD SetProcessTimeoutsProc(nsNanoXProcessTimeoutsProc aProc);
  NS_IMETHOD GetProcessTimeoutsProc(nsNanoXProcessTimeoutsProc * aProcOut);

private:

  static nsNanoXWindowCallback         gsWindowCreateCallback;
  static nsNanoXWindowCallback         gsWindowDestroyCallback;
  static nsNanoXEventDispatcher        gsEventDispatcher;
  static nsNanoXTimeToNextTimeoutFunc  gsTimeToNextTimeoutFunc;
  static nsNanoXProcessTimeoutsProc    gsProcessTimeoutsProc;
};
